## semweb 1.05+dfsg

=== Makefile ===
VERSION=1.05
    # don't forget to update src/AssemblyInfo.cs!!

########################

# Some checks to see if dependenies are available for
# optional assemblies.

npgsql_available := $(shell gacutil -l Npgsql | grep -c PublicKeyToken)
sqlite_available := $(shell gacutil -l Mono.Data.SqliteClient | grep -c PublicKeyToken)
mysql_available := $(shell gacutil -l MySql.Data | grep -c PublicKeyToken)

########################

# If PROFILE is empty, then our default target is to
# shell out a make for each profile.  Otherwise, we
# just build the profile we're given.  Since we can't
# build any of the .NET target files without a PROFILE,
# those targets are in the else condition.
ifeq "$(PROFILE)" ""

all:
	PROFILE=DOTNET1 make
	PROFILE=DOTNET2 make
#	PROFILE=SILVERLIGHT make
#	PROFILE=DOTNET3 make

# If we have a PROFILE specified.
else

ifeq "$(PROFILE)" "DOTNET1"
BIN=bin
MCS=mcs -d:DOTNET1
endif

ifeq "$(PROFILE)" "DOTNET2"
BIN=bin_generics
MCS=gmcs -d:DOTNET2
endif

ifeq "$(PROFILE)" "DOTNET3"
BIN=bin_linq
MCS=gmcs -d:DOTNET3 -langversion:linq
endif

ifeq "$(PROFILE)" "SILVERLIGHT"
BIN=bin_silverlight
MCS=smcs -d:SILVERLIGHT
endif

all: $(BIN)/SemWeb.dll $(BIN)/SemWeb.PostgreSQLStore.dll $(BIN)/SemWeb.MySQLStore.dll $(BIN)/SemWeb.SqliteStore.dll $(BIN)/SemWeb.SQLServerStore.dll $(BIN)/SemWeb.Sparql.dll $(BIN)/rdfstorage.exe $(BIN)/rdfquery.exe $(BIN)/euler.exe

# Core Library
	
MAIN_SOURCES = \
	src/AssemblyInfo.cs \
	src/NamespaceManager.cs src/Util.cs src/UriMap.cs \
	src/Resource.cs src/Statement.cs \
	src/Interfaces.cs \
	src/Store.cs src/MemoryStore.cs src/SQLStore.cs \
	src/RdfReader.cs src/RdfXmlReader.cs src/N3Reader.cs \
	src/RdfWriter.cs src/RdfXmlWriter.cs src/N3Writer.cs \
	src/Query.cs src/GraphMatch.cs src/LiteralFilters.cs \
	src/Inference.cs src/RDFS.cs src/Euler.cs src/SpecialRelations.cs \
	src/Algos.cs src/SparqlClient.cs

$(BIN)/SemWeb.dll: $(MAIN_SOURCES) Makefile
	mkdir -p $(BIN)
	$(MCS) -debug $(MAIN_SOURCES) -out:$(BIN)/SemWeb.dll -t:library \
		-r:System.Data -r:System.Web

# Auxiliary Assemblies

$(BIN)/SemWeb.Sparql.dll: src/SparqlEngine.cs src/SparqlProtocol.cs
	$(MCS) -debug src/SparqlEngine.cs src/SparqlProtocol.cs -out:$(BIN)/SemWeb.Sparql.dll \
		-t:library -r:$(BIN)/SemWeb.dll -r:$(BIN)/sparql-core.dll -r:$(BIN)/IKVM.GNU.Classpath.dll \
		-r:System.Web

$(BIN)/SemWeb.PostgreSQLStore.dll: src/PostgreSQLStore.cs
ifneq "$(npgsql_available)" "0"
	$(MCS) -debug src/PostgreSQLStore.cs -out:$(BIN)/SemWeb.PostgreSQLStore.dll -t:library \
		-r:$(BIN)/SemWeb.dll -r:System.Data -r:Npgsql
else
	@echo "SKIPPING compilation of SemWeb.PosgreSQLStore.dll because Npgsql assembly seems to be not available in the GAC.";
endif

$(BIN)/SemWeb.SqliteStore.dll: src/SQLiteStore.cs
ifneq "$(sqlite_available)" "0"
	$(MCS) -debug src/SQLiteStore.cs -out:$(BIN)/SemWeb.SqliteStore.dll -t:library \
		-r:$(BIN)/SemWeb.dll -r:System.Data -r:Mono.Data.SqliteClient
else
	@echo "SKIPPING compilation of SemWeb.SqliteStore.dll because Mono.Data.SqliteClient assembly seems to be not available in the GAC.";
endif
	
$(BIN)/SemWeb.MySQLStore.dll: src/MySQLStore.cs
ifneq "$(PROFILE)" "DOTNET1" # the MySql.Data lib we are compiling against is 2.0.
ifneq "$(mysql_available)" "0"
	$(MCS) -debug src/MySQLStore.cs -out:$(BIN)/SemWeb.MySQLStore.dll -t:library\
		 -r:$(BIN)/SemWeb.dll -r:System.Data -r:MySql.Data -d:CONNECTOR -lib:lib
	#$(MCS) -debug src/MySQLStore.cs -out:$(BIN)/SemWeb.MySQLStore-ByteFX.dll -t:library\
	# -r:$(BIN)/SemWeb.dll -r:System.Data -r:ByteFX.Data -d:BYTEFX
else
	@echo "SKIPPING compilation of SemWeb.MySQLStore.dll because MySql.Data assembly seems to be not available in the GAC.";
endif
endif

$(BIN)/SemWeb.SQLServerStore.dll: src/SQLServerStore.cs
	$(MCS) -debug src/SQLServerStore.cs -out:$(BIN)/SemWeb.SQLServerStore.dll -t:library\
		 -r:$(BIN)/SemWeb.dll -r:System.Data

# Utility programs

$(BIN)/rdfstorage.exe: tools/rdfstorage.cs
	$(MCS) -debug tools/rdfstorage.cs -out:$(BIN)/rdfstorage.exe -r:$(BIN)/SemWeb.dll -r:Mono.GetOptions
	
$(BIN)/rdfquery.exe: tools/rdfquery.cs
	$(MCS) -debug tools/rdfquery.cs -out:$(BIN)/rdfquery.exe -r:$(BIN)/SemWeb.dll -r:$(BIN)/SemWeb.Sparql.dll -r:Mono.GetOptions	

$(BIN)/euler.exe: tools/euler.cs
	$(MCS) -debug tools/euler.cs -out:$(BIN)/euler.exe -r:$(BIN)/SemWeb.dll -r:$(BIN)/SemWeb.Sparql.dll

endif
# that's the end of the test if we have a PROFILE given

# Generating documentation files

apidocxml: Makefile
	monodocer \
		-assembly:bin_generics/SemWeb.dll -assembly:bin_generics/SemWeb.Sparql.dll \
		-path:apidocxml --delete --pretty
	#mono /usr/lib/monodoc/monodocs2slashdoc.exe doc > SemWeb.docs.xml
	mkdir -p apidocs
	monodocs2html -source:apidocxml -dest:apidocs -template:docstemplate.xsl

# Generating the release package

package: all
	rm -rf package-workspace
	mkdir -p package-workspace/semweb-$(VERSION)
	cp -R bin bin_generics bin_silverlight src tools apidocs doc \
		ChangeLog Makefile README.txt semweb.mds semweb.sln \
		package-workspace/semweb-$(VERSION)
	mkdir package-workspace/semweb-$(VERSION)/examples
	cp examples/*.cs examples/Makefile examples/README.txt examples/getsomedata.sh \
		package-workspace/semweb-$(VERSION)/examples
	tar -czf packages/semweb-$(VERSION).tgz -C package-workspace \
		--exclude .svn \
		semweb-$(VERSION)
	rm -f packages/semweb.zip
	cd package-workspace/semweb-$(VERSION); cp -R ../../apidocxml monodoc; zip -r -q ../../packages/semweb.zip * -x "*.svn*"
	rm -rf package-workspace
	
deploy: package
	scp packages/semweb-$(VERSION).tgz packages/semweb.zip occams.info:www/code/semweb

clean:
	rm bin*/SemWeb.dll* bin*/SemWeb.Sparql.dll* \
	bin*/SemWeb.PostgreSQLStore.dll* bin*/SemWeb.SqliteStore.dll* bin*/SemWeb.MySQLStore.dll* \
	bin*/rdfstorage.exe* bin*/rdfquery.exe* bin*/euler.exe*

=== examples/Makefile ===
all: *.cs
	ln -sf ../bin/SemWeb.dll .;
	ln -sf ../bin/SemWeb.Sparql.dll .;
	ln -sf ../bin/sparql-core.dll .;
	ln -sf ../bin/IVKM.GNU.Classpath.dll .;
	for sample in `ls *.cs`; do mcs -debug $$sample -r:SemWeb.dll -r:SemWeb.Sparql.dll ; done

runtests: all
	mono helloworld.exe > helloworld.output.rdf

clean:
	rm *.exe*

=== debian/changelog ===
semweb (1.05+dfsg-5) unstable; urgency=low

  * Team upload
  * Rebuild for CLR 4.0 transition
  * [800adf2] Use debsrc 3.0 (quilt)
  * [17253c9] Merge -arch and -indep things together.
    There are only Arch: all packages here, so there's no point in having all
    that cruft.
  * [73dca30] Drop deprecated cli.make include

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 21 Jan 2012 02:20:34 +0800

semweb (1.05+dfsg-4) unstable; urgency=low

  * debian/control:
    + Fix typo in monodoc-semweb-manual description (Closes: #557701)
    + Update build-deps to Mono 2.4.3 standards, and fix broken MySQL
      Connector/NET build-dep
  * debian/monodoc-semweb-manual.postinst,
    debian/monodoc-semweb-manual.postrm:
    + Don't manually fiddle the search index (this is handled by a
      DPKG trigger)

 -- Jo Shields <directhex@apebox.org>  Mon, 09 Aug 2010 10:37:05 +0100

semweb (1.05+dfsg-3) unstable; urgency=low

  [ David Paleino ]
  * debian/rules:
    + fix docs generation commands (Closes: #533928)
    + rewritten using override targets and cli-common integration
    + fix clean target, FTBFS because of missing directory
  * debian/control:
    + raise dependency on debhelper to >= 7.0.50, to use override
      targets
    + raise dependency on cli-common-dev to >= 0.5.7, to use dh7
      integration
    + bump Build-Depends from libmysql5.0-cil to libmysql6.0-cil
    + added ${misc:Depends} to monodoc-semweb-manual dependencies
    + Standards-Version bumped to 3.8.3:
      - move from Section libs to cli-mono
  * debian/patches/:
    + converted patches to quilt (also change debian/rules and
      debian/control)
    + added DEP-3 headers
  * debian/copyright: updated FSF postal address
  * debian/monodoc-semweb-manual.post*: fix monodoc calls, removed
    old postinst hack
  * debian/README.source added

  [ Mirco Bauer ]
  * debian/control:
    + Updated Vcs-* fields for the migrated git repository.
  * debian/patches/04-use_csc_as_compiler.patch
    debian/patches/04-use_mono-csc_as_compiler.patch
    debian/control:
    + Use mono-csc instead of csc and updated mono-devel build-dep.

 -- David Paleino <d.paleino@gmail.com>  Sat, 26 Sep 2009 00:00:42 +0200

semweb (1.05+dfsg-2) unstable; urgency=low

  * Update for Mono 2.0 transition
    + debian/patches/use_csc_as_compiler.dpatch:
      - Compiler is hard-coded in Makefile; change it
  * No-change standards bump to 3.8.0
  * Tweak watch file to make uscan aware of mangled version

 -- Jo Shields <directhex@apebox.org>  Mon, 02 Mar 2009 15:16:38 +0000

semweb (1.05+dfsg-1) unstable; urgency=low

  * DFSG version of SemWeb 1.05
    (deleted all pre-compiled binaries from the tarball)
    + For the record here a list of the deleted files:
      bin/IKVM.GNU.Classpath.dll
      bin/IKVM.Runtime.dll
      bin/Mono.GetOptions.dll
      bin/SemWeb.PostgreSQLStore.dll
      bin/SemWeb.SQLServerStore.dll
      bin/SemWeb.Sparql.dll
      bin/SemWeb.SqliteStore.dll
      bin/SemWeb.dll
      bin/euler.exe
      bin/rdfquery.exe
      bin/rdfstorage.exe
      bin/sparql-core.dll
      bin_generics/IKVM.GNU.Classpath.dll
      bin_generics/IKVM.Runtime.dll
      bin_generics/Mono.GetOptions.dll
      bin_generics/SemWeb.MySQLStore.dll
      bin_generics/SemWeb.PostgreSQLStore.dll
      bin_generics/SemWeb.SQLServerStore.dll
      bin_generics/SemWeb.Sparql.dll
      bin_generics/SemWeb.SqliteStore.dll
      bin_generics/SemWeb.dll
      bin_generics/euler.exe
      bin_generics/rdfquery.exe
      bin_generics/rdfstorage.exe
      bin_generics/sparql-core.dll
  * Initial release.

 -- Mirco Bauer <meebey@debian.org>  Sun, 04 May 2008 14:09:48 +0200

=== debian/control ===
Source: semweb
Section: cli-mono
Priority: optional
Maintainer: Debian CLI Libraries Team <pkg-cli-libs-team@lists.alioth.debian.org>
Uploaders: Mirco Bauer <meebey@debian.org>
Build-Depends: debhelper (>= 7.0.50),
 cli-common-dev (>= 0.5.7),
 sharutils,
 mono-devel (>= 2.4.3),
 pkg-config,
 monodoc-base,
 libmysql-cil-dev
Standards-Version: 3.9.2
Homepage: http://razor.occams.info/code/semweb/
Vcs-Browser: http://git.debian.org/?p=pkg-cli-libs/packages/semweb.git
Vcs-Git: git://git.debian.org/pkg-cli-libs/packages/semweb.git

Package: libsemweb1.0-cil
Architecture: all
Suggests: monodoc-semweb-manual
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}
Description: Semantic Web/RDF library
 SemWeb is a Semantic Web/RDF library written in C# for Mono and Microsoft .NET
 Framework. The library can be used for reading and writing RDF (XML, N3),
 keeping RDF in persistent storage (memory, MySQL, etc.), querying persistent
 storage via simple graph matching and SPARQL, and making SPARQL queries to
 remote endpoints. Limited RDFS and general-purpose inferencing is also
 possible.

Package: monodoc-semweb-manual
Section: doc
Architecture: all
Depends: monodoc-manual, ${misc:Depends}
Description: compiled XML documentation for SemWeb
 SemWeb is a Semantic Web/RDF library written in C# for Mono and Microsoft .NET
 Framework. The library can be used for reading and writing RDF (XML, N3),
 keeping RDF in persistent storage (memory, MySQL, etc.), querying persistent
 storage via simple graph matching and SPARQL, and making SPARQL queries to
 remote endpoints. Limited RDFS and general-purpose inferencing is also
 possible.
 .
 This package contains the compiled XML documentation for SemWeb

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

DEB_VERSION = $(shell dpkg-parsechangelog | grep ^Vers | cut -d\  -f2)
VERSION = $(shell echo $(DEB_VERSION) | sed 's,-.*,,' | sed 's,+dfsg.*,,')
DEB_CLI_ABI_VERSION = 1.0
DEB_CLI_API_VERSION = 1.0.5
LIBS =  bin_generics/SemWeb.dll \
	bin_generics/SemWeb.PostgreSQLStore.dll \
	bin_generics/SemWeb.MySQLStore.dll \
	bin_generics/SemWeb.SqliteStore.dll \
	bin_generics/SemWeb.SQLServerStore.dll

override_dh_auto_build:
	# unpack signing key
	cd debian && uudecode < semweb.snk.uu

	# compile
	dh_auto_build -- PROFILE=DOTNET2 $(LIBS)

	# sign libs
	for LIB in $(LIBS); do \
		sn -R $$LIB debian/semweb.snk; \
	done

	# build API docs
	#for LIB in $(LIBS); do \
	#	mdoc update -i $$LIB -o $(CURDIR)/bin_generics/monodocer; \
	#done
	mdoc update -o $(CURDIR)/bin_generics/monodocer \
	  bin_generics/SemWeb.dll
	mdoc assemble -o $(CURDIR)/bin_generics/SemWeb \
	  -f ecma $(CURDIR)/bin_generics/monodocer

debian/semweb-$(DEB_CLI_ABI_VERSION).pc: debian/semweb.pc
	cat $< | sed -e 's/#VERSION#/$(VERSION)/;' | \
		sed -e 's/#DEB_CLI_ABI_VERSION#/$(DEB_CLI_ABI_VERSION)/' > \
		$@

override_dh_auto_install: debian/semweb-$(DEB_CLI_ABI_VERSION).pc
	# pkg-config
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pkgconfig
	install -m644 debian/semweb-$(DEB_CLI_ABI_VERSION).pc \
		debian/tmp/usr/lib/pkgconfig/
	dh_auto_install

override_dh_makeclilibs:
	dh_makeclilibs -m $(DEB_CLI_API_VERSION)

override_dh_auto_clean:
	# clean up our signing key
	rm -f debian/semweb.snk
	# clean up our .pc file
	rm -f debian/semweb-$(DEB_CLI_ABI_VERSION).pc
	# clean up our API docs
	rm -f bin_generics/SemWeb.tree \
	      bin_generics/SemWeb.zip
	rm -rf bin_generics/monodocer

	# workaround for broken "make clean"
	[ -d bin_generics/ ] || mkdir bin_generics/
	for FILE in $(LIBS) \
	  bin_generics/SemWeb.Sparql.dll \
	  bin_generics/rdfstorage.exe \
	  bin_generics/rdfquery.exe \
	  bin_generics/euler.exe; do \
		touch $$FILE; \
	done

	dh_auto_clean

%:
	dh $@ --with=cli

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
	http://razor.occams.info/code/semweb/ semweb-([\d\.]+)\.tgz
